;; The first three lines of this file were inserted by DrScheme. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname orig-step) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #8(#t constructor repeating-decimal #f #t none #f ())))
(define-struct closure (arg body env))

(define (interp expr env)
  (cond
    [(number? expr) expr]
    [(symbol? expr)
     (cadr (assq expr env))]
    [else
     (let ([op (car expr)])
       (cond
         [(eq? op '+)
          (+ (interp (cadr expr) env)
             (interp (caddr expr) env))]
         [(eq? op '-)
          (- (interp (cadr expr) env)
             (interp (caddr expr) env))]
         [(eq? op 'zero?)
          (zero? (interp (cadr expr) env))]
         [(eq? op 'if)
          (if (interp (cadr expr) env)
              (interp (caddr expr) env)
              (interp (cadddr expr) env))]
         [(eq? op 'let)
          (let ([rhs-val
                 (interp (cadr (caadr expr)) env)])
            (interp (caddr expr)
                    (cons (list (car (caadr expr))
                                rhs-val)
                          env)))]
         [(eq? op 'lambda)
          (make-closure (caadr expr)
                        (caddr expr)
                        env)]
         [else
          (let ([clos (interp (car expr) env)]
                [arg-val (interp (cadr expr) env)])
            (interp (closure-body clos)
                    (cons
                     (list (closure-arg clos)
                           arg-val)
                     (closure-env clos))))]))]))

(interp '(let ([x (+ 1 2)])
           (+ x 4))
        '())
