;; The first three lines of this file were inserted by DrScheme. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname lift-step) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #8(#t constructor repeating-decimal #f #t none #f ())))
(define-struct closure (arg body env))

(define (comp expr)
  (cond
    [(number? expr) (lambda (env) expr)]
    [(symbol? expr)
     (lambda (env)
       (cadr (assq expr env)))]
    [else
     (let ([op (car expr)])
       (cond
         [(eq? op '+)
          (let ([a (comp (cadr expr))]
                [b (comp (caddr expr))])
            (lambda (env) (+ (a env) (b env))))]
         [(eq? op '-)
          (let ([a (comp (cadr expr))]
                [b (comp (caddr expr))])
            (lambda (env) (- (a env) (b env))))]
         [(eq? op 'zero?)
          (let ([a (comp (cadr expr))])
            (lambda (env) (zero? (a env))))]
         [(eq? op 'if)
          (let ([a (comp (cadr expr))]
                [b (comp (caddr expr))]
                [c (comp (cadddr expr))])
            (lambda (env)
              (if (a env)
                  (b env)
                  (c env))))]
         [(eq? op 'let)
          (let ([rhs (comp (cadr (caadr expr)))]
                [body (comp (caddr expr))]
                [id (car (caadr expr))])
            (lambda (env)
              (let ([rhs-val (rhs env)])
                (body
                 (cons (list id
                             rhs-val)
                       env)))))]
         [(eq? op 'lambda)
          (let ([body (comp (caddr expr))]
                [id (caadr expr)])
            (lambda (env)
              (make-closure id
                            body
                            env)))]
         [else
          (let ([a (comp (car expr))]
                [b (comp (cadr expr))])
            (lambda (env)
              (let ([clos (a env)]
                    [arg-val (b env)])
                ((closure-body clos)
                 (cons
                  (list (closure-arg clos)
                        arg-val)
                  (closure-env clos))))))]))]))

(comp '(let ([x (+ 1 2)])
         (+ x 4)))
